#include "utility.h"
#include "resource.h"

ATOM MyRegisterClass(PWNDCLASSEX,HINSTANCE);
HWND InitInstance(HINSTANCE, int);
BOOL ScreenShot(HDC, POINT, POINT);
BOOL GetFileName(PTCHAR);

NOTIFYICONDATA g_nid;
HINSTANCE g_hInstance;
HWND g_hWnd;
BOOL g_State = FALSE;

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	HWND hWndPre;
	if(hWndPre = FindWindow("MYSCREENSHOT", 0))
//		SendMessage(hWndPre, WM_DESTROY, 0, 0);
		ExitProcess(0);

	g_hInstance = hInstance;
	HWND hWnd;
	MSG msg;
	WNDCLASSEX WndClass;
	MyRegisterClass(&WndClass, hInstance);

	if (!(hWnd = InitInstance(hInstance, nCmdShow))) 
		return FALSE;
	g_hWnd = hWnd;

	g_nid.cbSize = sizeof(NOTIFYICONDATA);
	g_nid.hWnd = hWnd;   
	g_nid.uID = 0;
	g_nid.uFlags = NIF_ICON | NIF_MESSAGE |NIF_TIP;   
	g_nid.uCallbackMessage = MY_ICON_MESSAGE;
	g_nid.hIcon = LoadIcon(hInstance,(LPCTSTR)IDI_OFF); 
	strcpy(g_nid.szTip, "Screenshot Helper v1.0\nCONTROL+ALT+A to start.\nSUN 2012");
	Shell_NotifyIcon(NIM_ADD,&g_nid);

	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return msg.wParam;
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	PAINTSTRUCT ps;
	HDC hdc;
	static POINT pointPositive, pointNegative, pointPresent;
	static HDC hSrcDC;

	switch (message) 
	{
	case WM_PAINT:
		{
			hdc = BeginPaint(hWnd, &ps);
				if(g_State)
				{
					InvalidateRect(hWnd, 0, TRUE);
					HPEN hPen = CreatePen(PS_DOT, 1, RGB(0,0,0));
					HPEN hOldPen = (HPEN)SelectObject(hdc, hPen);
					MoveToEx(hdc, pointPositive.x, pointPositive.y, 0);
					LineTo(hdc, pointPresent.x, pointPositive.y);
					MoveToEx(hdc, pointPresent.x, pointPositive.y, 0);
					LineTo(hdc, pointPresent.x, pointPresent.y);
					MoveToEx(hdc, pointPresent.x, pointPresent.y, 0);
					LineTo(hdc, pointPositive.x, pointPresent.y);
					MoveToEx(hdc, pointPositive.x, pointPresent.y, 0);
					LineTo(hdc, pointPositive.x, pointPositive.y);
					hPen = (HPEN)SelectObject(hdc, hOldPen);
				}
			EndPaint(hWnd, &ps);
		}
		break;

	case WM_DESTROY:
		{
			Shell_NotifyIcon(NIM_DELETE, &g_nid);
			UnregisterHotKey(hWnd, 1346);
			UnregisterHotKey(hWnd, 1347);
			PostQuitMessage(0);
		}
		break;

	case MY_ICON_MESSAGE:
		{
			switch(lParam)
			{
			case WM_RBUTTONDOWN:
				{
					HMENU hMenu = CreateMenu();
					HMENU hPopupMenu = CreateMenu();
					AppendMenu(hMenu, MF_POPUP, (UINT_PTR)hPopupMenu, 0);
					AppendMenu(hPopupMenu, MF_STRING, IDM_RUN, "&Run");
					AppendMenu(hPopupMenu, MF_SEPARATOR, 0, 0);
					AppendMenu(hPopupMenu, MF_STRING, IDM_QUIT, "&Quit");
					POINT point;
					GetCursorPos(&point);
					SetForegroundWindow(hWnd);
					TrackPopupMenu(hPopupMenu, TPM_LEFTALIGN, point.x, point.y, 0, hWnd, 0);
				}
				break;

			case WM_LBUTTONDBLCLK:
				SendMessage(hWnd, WM_COMMAND, MAKEWPARAM(IDM_RUN, 0), 0);
				break;
			}
		}
		break;

	case WM_COMMAND:
		{
			switch (LOWORD(wParam))
			{
			case IDM_QUIT:
				DestroyWindow(hWnd);
				break;
			case IDM_RUN:
				{
					g_nid.hIcon = LoadIcon(g_hInstance, (LPCTSTR)IDI_ON); 
					Shell_NotifyIcon(NIM_MODIFY, &g_nid);
				
					hSrcDC = GetDC(GetDesktopWindow());

					HMODULE hModule = LoadLibrary("User32.dll");
					lpfnSetLayeredWindowAttributes myfunc = (lpfnSetLayeredWindowAttributes)GetProcAddress(hModule, "SetLayeredWindowAttributes"); 
					FreeLibrary(hModule);
					ShowWindow(hWnd, SW_MAXIMIZE);
					myfunc(hWnd, 0, 100, LWA_ALPHA);

					g_State = TRUE;
				}
				break;
			}
		}
		break;
		
	case WM_LBUTTONDOWN:
		{
			if(g_State)
			{
				GetCursorPos(&pointPositive);
				GetCursorPos(&pointPresent);
			}
		}
		break;

	case WM_LBUTTONUP:
		{
			if(g_State)
			{
				GetCursorPos(&pointNegative);
				ScreenShot(hSrcDC, pointPositive, pointNegative);

				SendMessage(hWnd, WM_HIDE, 0, 0);
			}
		}
		break;

	case WM_KEYDOWN:
		{
			if(wParam == VK_SPACE || wParam == VK_ESCAPE)
				SendMessage(hWnd, WM_HIDE, 0, 0);
		}
		break;

	case WM_RBUTTONDOWN:
		{
			SendMessage(hWnd, WM_HIDE, 0, 0);
		}
		break;

	case WM_HOTKEY:
		{
			if(HIWORD(lParam) == 65 || HIWORD(lParam) == 222)
				SendMessage(hWnd, WM_COMMAND, MAKEWPARAM(IDM_RUN, 0), 0);
		}
		break;
		
	case WM_HIDE:
		{
			if(g_State)
			{
				ShowWindow(hWnd, SW_HIDE);

				g_nid.hIcon = LoadIcon(g_hInstance, (LPCTSTR)IDI_OFF); 
				Shell_NotifyIcon(NIM_MODIFY, &g_nid);

				g_State = FALSE;
				pointPositive.x = pointPositive.y = pointPresent.x = pointPresent.y = 0;
			}
		}
		break;

	case WM_MOUSEMOVE:
		{
			if(g_State && wParam == MK_LBUTTON)
			{
				pointPresent.x = LOWORD(lParam);
				pointPresent.y = HIWORD(lParam);
			}
		}
		break;

	default:
		return DefWindowProc(hWnd, message, wParam, lParam);	
   }

   return 0;
}

BOOL ScreenShot(HDC hSrcDC, POINT p1, POINT p2)
{
	int nWidth = (int)fabs(p1.x - p2.x);
	int nHeight = (int)fabs(p1.y - p2.y);
	int nx = (p1.x < p2.x) ? p1.x : p2.x;			// x of left & top POINT
	int ny = (p1.y < p2.y) ? p1.y : p2.y;			// y of left & top POINT

	if(!nWidth || !nHeight)
		return FALSE;

	HDC hMemDC = CreateCompatibleDC(hSrcDC); 
	HBITMAP hBitmap = CreateCompatibleBitmap(hSrcDC, nWidth, nHeight); 
	HBITMAP hOldBitmap = (HBITMAP)SelectObject(hMemDC, hBitmap); 
	BitBlt(hMemDC, 0, 0, nWidth, nHeight, hSrcDC, nx, ny, SRCCOPY);  
	hBitmap = (HBITMAP)SelectObject(hMemDC, hOldBitmap);

	TCHAR szFileName[FILE_NAME_BUFFER] = "";

	if(!GetFileName(szFileName))
		return FALSE;

	PVOID lpvpxldata;

	DWORD dwBitmapArraySize;
	DWORD nBitsOffset;
	DWORD lImageSize;
	DWORD lFileSize;

	BITMAPINFO bmInfo;
	BITMAPFILEHEADER bmFileHeader;
	HANDLE hbmfile;
	DWORD dwWritten;

	dwBitmapArraySize = ((((nWidth*32) + 31) & ~31) >> 3) * nHeight;
	lpvpxldata = HeapAlloc(GetProcessHeap(), HEAP_NO_SERIALIZE, dwBitmapArraySize);
	ZeroMemory(lpvpxldata, dwBitmapArraySize);

	ZeroMemory(&bmInfo, sizeof(BITMAPINFO));
	bmInfo.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
	bmInfo.bmiHeader.biWidth = nWidth;
	bmInfo.bmiHeader.biHeight = nHeight;
	bmInfo.bmiHeader.biPlanes = 1;
	bmInfo.bmiHeader.biBitCount = 32;
	bmInfo.bmiHeader.biCompression = BI_RGB;

	ZeroMemory(&bmFileHeader, sizeof(BITMAPFILEHEADER));
	nBitsOffset = sizeof(BITMAPFILEHEADER) + bmInfo.bmiHeader.biSize;
	lImageSize = ((((bmInfo.bmiHeader.biWidth * bmInfo.bmiHeader.biBitCount) + 31) & ~31)>> 3) * bmInfo.bmiHeader.biHeight;
	lFileSize = nBitsOffset + lImageSize;
	bmFileHeader.bfType = 'B' + ('M'<<8);
	bmFileHeader.bfSize = lFileSize;
	bmFileHeader.bfOffBits = nBitsOffset;

	GetDIBits(hMemDC, hBitmap, 0, bmInfo.bmiHeader.biHeight, lpvpxldata, &bmInfo, DIB_RGB_COLORS);

	hbmfile = CreateFile(szFileName, GENERIC_WRITE, FILE_SHARE_WRITE, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);

	WriteFile(hbmfile, &bmFileHeader, sizeof(BITMAPFILEHEADER), &dwWritten, 0);
	WriteFile(hbmfile, &bmInfo, sizeof(BITMAPINFO), &dwWritten, 0);
	WriteFile(hbmfile, lpvpxldata, lImageSize, &dwWritten, 0);
	CloseHandle(hbmfile);

	HeapFree(GetProcessHeap(), HEAP_NO_SERIALIZE, lpvpxldata);
	ReleaseDC(GetDesktopWindow(), hSrcDC);
	DeleteDC(hMemDC);
	DeleteObject(hBitmap);

	return TRUE;
}

BOOL GetFileName(PTCHAR lpszFullFileName)
{
	OPENFILENAME SaveFileName;
	SaveFileName.lStructSize = sizeof(OPENFILENAME);
	SaveFileName.hwndOwner = 0;
	SaveFileName.hInstance = 0;
	SaveFileName.lpstrFilter = "BMP files(*.bmp)\0*.bmp\0";
	SaveFileName.lpstrCustomFilter = 0;
	SaveFileName.nFilterIndex = 0;
	SaveFileName.lpstrTitle = "Save as ... ";
	SaveFileName.lpstrFile = lpszFullFileName;
	TCHAR szFileName[100];
	SaveFileName.lpstrFileTitle = szFileName;
	SaveFileName.nMaxFileTitle = 100;
	SaveFileName.nMaxFile = FILE_NAME_BUFFER;
	SaveFileName.Flags = 0;
	SaveFileName.lpstrInitialDir = 0;
	SaveFileName.nFileOffset = 0;
	SaveFileName.nFileExtension = 0;
	SaveFileName.lpstrDefExt = "bmp";
	SaveFileName.lCustData = 0;
	SaveFileName.lpfnHook = 0;
	SaveFileName.lpTemplateName = 0;

	if(!GetSaveFileName(&SaveFileName))
		return FALSE;

	return TRUE;
}




