#include "utility.h"
#include "resource.h"
#include <atlimage.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <math.h>
#include <assert.h>
#include<vector>
#include<iostream>
using namespace std;

// Windows include files 

#ifdef _WIN32
#include <windows.h>
#endif

// OpenGL include files 

#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>


static int a = 28; //aΪģͱţĸģͽͼЧþa=٣ģtable_4ͼЧãa=4
static int b = 1;

typedef struct Vertex {
  float x, y, z;
} Vertex;

typedef struct Face {
  Face(void) : nverts(0), verts(0) {};
  int nverts;
  Vertex **verts;
  float normal[3];
} Face;

typedef struct Mesh {
  Mesh(void) : nverts(0), verts(0), nfaces(0), faces(0) {};
  int nverts;
  Vertex *verts;
  long nfaces;
  Face *faces;

 vector<Vertex>point;

} Mesh;



////////////////////////////////////////////////////////////
// GLOBAL VARIABLES
////////////////////////////////////////////////////////////

//// Program arguments
//char* buffName;
static char* glfilename()
{
	static char *filename = 0;
	//static int b = 1;

	char* pszPath1 = (char*)malloc(30*sizeof(char));
	memset(pszPath1,0,30);
	char* pszNum1 = (char*)malloc(5*sizeof(char));
	memset(pszNum1,0,5);

	strcpy_s(pszPath1,30,"table_");  //ģ͵
	_itoa(a,pszNum1,10);
	strcat_s(pszPath1,30,pszNum1);
	//b++;
	
	strcat_s(pszPath1,30,".off");
	filename = pszPath1;
	/*delete(pszPath1);
	pszPath1 = NULL;
	delete(pszNum1);
	pszNum1 = NULL;*/
	return filename;
}
static char* filename = glfilename();

// GLUT variables 

static int GLUTwindow = 0;
static int GLUTwindow_height = 800;
static int GLUTwindow_width = 800;
static int GLUTmouse[2] = { 0, 0 };
static int GLUTbutton[3] = { 0, 0, 0 };
static int GLUTarrows[4] = { 0, 0, 0, 0 };
static int GLUTmodifiers = 0;



// Display variables

static int scaling = 0; //ű
static int translating = 0;
static int rotating = 0;//ת
static float scale = 1.0;
static float center[3] = { 0.0, 0.0, 0.0 };
static float rotation[3] = { 0.0, 0.0, 0.0 };
static float translation[3] = { 0.0, 0.0, -4.0 };

ATOM MyRegisterClass(PWNDCLASSEX,HINSTANCE);
HWND InitInstance(HINSTANCE, int);
BOOL ScreenShot(HDC, POINT, POINT);
//BOOL GetFileName(PTCHAR);

// Mesh variables

static Mesh *mesh = NULL;


PAINTSTRUCT ps;
HDC hdc;
static POINT pointPositive, pointNegative, pointPresent;
static HDC hSrcDC;

////////////////////////////////////////////////////////////
// OFF FILE READING CODE
////////////////////////////////////////////////////////////

Mesh *
ReadOffFile(const char *filename)
{
  int i;

  // Open file
  FILE *fp;
  if (!(fp = fopen(filename, "r"))) {
    fprintf(stderr, "Unable to open file %s\n", filename);
    return 0;
  }

  // Allocate mesh structure
  Mesh *mesh = new Mesh();
  if (!mesh) {
    fprintf(stderr, "Unable to allocate memory for file %s\n", filename);
    fclose(fp);
    return 0;
  }

  // Read file
  int nverts = 0;
  int nfaces = 0;
  int nedges = 0;
  int line_count = 0;
  char buffer[1024];
  while (fgets(buffer, 1023, fp)) {
    //Increment line counter
    line_count++;

    // Skip white space
    char *bufferp = buffer;
    while (isspace(*bufferp)) bufferp++;

    // Skip blank lines and comments
    if (*bufferp == '#') continue;
    if (*bufferp == '\0') continue;

    // Check section
    if (nverts == 0) {
      // Read header 
      if (!strstr(bufferp, "OFF")) {
        // Read mesh counts
        if ((sscanf(bufferp, "%d%d%d", &nverts, &nfaces, &nedges) != 3) || (nverts == 0)) {
          fprintf(stderr, "Syntax error reading header on line %d in file %s\n", line_count, filename);
          fclose(fp);
          return NULL;
        }

        // Allocate memory for mesh  Ϊڴ
        mesh->verts = new Vertex [nverts];
        assert(mesh->verts);
        mesh->faces = new Face [nfaces];
        assert(mesh->faces);
      }
    }
    else if (mesh->nverts < nverts) {
      // Read vertex coordinates   ȡ
      Vertex& vert = mesh->verts[mesh->nverts++];
      if (sscanf(bufferp, "%f%f%f", &(vert.x), &(vert.y), &(vert.z)) != 3) {
        fprintf(stderr, "Syntax error with vertex coordinates on line %d in file %s\n", line_count, filename);
        fclose(fp);
        return NULL;
      }
    }
    else if (mesh->nfaces < nfaces) {
      // Get next face
      Face& face = mesh->faces[mesh->nfaces++];

      // Read number of vertices in face 
      bufferp = strtok(bufferp, " \t");
      if (bufferp) face.nverts = atoi(bufferp);
      else {
        fprintf(stderr, "Syntax error with face on line %d in file %s\n", line_count, filename);
        fclose(fp);
        return NULL;
      }

      // Allocate memory for face vertices
      face.verts = new Vertex *[face.nverts];
      assert(face.verts);

      // Read vertex indices for face
      for (i = 0; i < face.nverts; i++) {
        bufferp = strtok(NULL, " \t");
        if (bufferp) face.verts[i] = &(mesh->verts[atoi(bufferp)]);
        else {
          fprintf(stderr, "Syntax error with face on line %d in file %s\n", line_count, filename);
          fclose(fp);
          return NULL;
        }
      }

      // Compute normal for face
      face.normal[0] = face.normal[1] = face.normal[2] = 0;
      Vertex *v1 = face.verts[face.nverts-1];
      for (i = 0; i < face.nverts; i++) {
        Vertex *v2 = face.verts[i];
        face.normal[0] += (v1->y - v2->y) * (v1->z + v2->z);
        face.normal[1] += (v1->z - v2->z) * (v1->x + v2->x);
        face.normal[2] += (v1->x - v2->x) * (v1->y + v2->y);
        v1 = v2;
      }

      // Normalize normal for face
      float squared_normal_length = 0.0;
      squared_normal_length += face.normal[0]*face.normal[0];
      squared_normal_length += face.normal[1]*face.normal[1];
      squared_normal_length += face.normal[2]*face.normal[2];
      float normal_length = sqrt(squared_normal_length);
      if (normal_length > 1.0E-6) {
        face.normal[0] /= normal_length;
        face.normal[1] /= normal_length;
        face.normal[2] /= normal_length;
      }
    }
    else {
      // Should never get here
      fprintf(stderr, "Found extra text starting at line %d in file %s\n", line_count, filename);
      break;
    }
  }

  // Check whether read all faces
  if (nfaces != mesh->nfaces) {
    fprintf(stderr, "Expected %d faces, but read only %d faces in file %s\n", nfaces, mesh->nfaces, filename);
  }

  // Close file
  fclose(fp);

  // Return mesh 
  return mesh;
}


void GLUTRedraw(void)
{
 
  // Setup viewing transformation
  glLoadIdentity();//ͶӰ
  glScalef(scale, scale, scale);   //ģź
  glTranslatef(translation[0], translation[1], 0.0);//ܣXƽxλ(xз)Yƽyλ(yз)Zƽzλ(zз)

  // Set projection transformation
  glMatrixMode(GL_PROJECTION);//ѡͶӰ
  glLoadIdentity();//ͶӰ
  gluPerspective(45.0, (GLfloat) GLUTwindow_width /(GLfloat) GLUTwindow_height, 0.1, 100.0);
  //ӿڴС

   gluLookAt(          //Ҳϵнжλ
        5, 0, 0,
        0, 0, -5,
        0, 0, 1);

  // Set camera transformation
  glMatrixMode(GL_MODELVIEW);    //   GL_PROJECTION      //ѡģ͹۲
  glLoadIdentity();
  glTranslatef(translation[0],translation[1] ,translation[2]); //       
  glScalef(scale, scale, scale);
  glRotatef(rotation[0], 1.0, 0.0, 0.0);   //ת
  glRotatef(rotation[1], 0.0, 1.0, 0.0);
  glRotatef(rotation[2], 0.0, 0.0, 1.0);
  glTranslatef(-center[0], -center[1], -center[2]); //ƽ

  // Clear window 
  glClearColor(1.0, 1.0, 1.0, 1.0);
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  // Set lights
  static GLfloat light0_position[] = { 3.0, 4.0, 5.0, 0.0 };
  glLightfv(GL_LIGHT0, GL_POSITION, light0_position);//Դ
  static GLfloat light1_position[] = { -3.0, -2.0, -3.0, 0.0 };
  glLightfv(GL_LIGHT1, GL_POSITION, light1_position);//Դ

  // Set material
  static GLfloat material[] = { 1.0, 0.5, 0.5, 1.0 };
  glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, material); //ָڹռĵǰ

  // Draw faces
  for (int i = 0; i < mesh->nfaces; i++) {
    Face& face = mesh->faces[i];
    glBegin(GL_POLYGON);
    glNormal3fv(face.normal);//÷ָ
    for (int j = 0; j < face.nverts; j++) {
      Vertex *vert = face.verts[j];
      glVertex3f(vert->x, vert->y, vert->z);//ֵָ
    }
    glEnd();
  }

  // Swap buffers 
  glutSwapBuffers();   //glutSwapBuffersOpenGLGLUT߰ʵ˫弼һҪ
}    

void GLUTStop(void)
{
  // Destroy window 
  glutDestroyWindow(GLUTwindow);

  // Exit
  exit(0);
}

void GLUTResize(int w, int h)//ûɶ
{
  // Resize window
  glViewport(0, 0, w, h);

  // Remember window size 
  GLUTwindow_width = w;
  GLUTwindow_height = h;

  // Redraw
  glutPostRedisplay();//ǵǰҪ»
}


void GLUTMouse(int button, int state, int x, int y)
{
  // Invert y coordinate
  y = GLUTwindow_height - y;
  
  // Process mouse button event
  rotating = (button == GLUT_LEFT_BUTTON);
  scaling = (button == GLUT_MIDDLE_BUTTON);
  translating = (button == GLUT_RIGHT_BUTTON);
  if (rotating || scaling || translating) glutIdleFunc(GLUTRedraw);
  else glutIdleFunc(0);

  // Remember button state 
  int b = (button == GLUT_LEFT_BUTTON) ? 0 : ((button == GLUT_MIDDLE_BUTTON) ? 1 : 2);
  GLUTbutton[b] = (state == GLUT_DOWN) ? 1 : 0;

  // Remember modifiers 
  GLUTmodifiers = glutGetModifiers();

   // Remember mouse position 
  GLUTmouse[0] = x;
  GLUTmouse[1] = y;
}

void GLUTSpecial(int key, int x, int y)//ûɶ
{
  // Invert y coordinate
  y = GLUTwindow_height - y;

  // Process keyboard button event 

  // Remember mouse position 
  GLUTmouse[0] = x;
  GLUTmouse[1] = y;

  // Remember modifiers 
  GLUTmodifiers = glutGetModifiers();

  // Redraw
  glutPostRedisplay();//ǵǰʾ
}


void GLUTKeyboard(unsigned char key, int x, int y)
{
  // Process keyboard button event 
  switch (key) {
  case 'Q':
  case 'q':
    GLUTStop();
    break;

  case 27: // ESCAPE
    GLUTStop();
    break;
  case 'a':
	/*rotation[0] += -0.6 * (y - GLUTmouse[1]);
    rotation[2] += 0.6 * (x - GLUTmouse[0]);*/
	  //grab();
	  break;
  }

  // Remember mouse position 
  GLUTmouse[0] = x;
  GLUTmouse[1] = GLUTwindow_height - y;

  // Remember modifiers 
  GLUTmodifiers = glutGetModifiers();
}
//======================================================
void GLUTMainLoop(void)
{
  // Compute bounding box    ߽
  float bbox[2][3] = { { 1.0E30F, 1.0E30F, 1.0E30F }, { -1.0E30F, -1.0E30F, -1.0E30F } };
  for (int i = 0; i < mesh->nverts; i++) {
    Vertex& vert = mesh->verts[i];
    if (vert.x < bbox[0][0]) bbox[0][0] = vert.x;
    else if (vert.x > bbox[1][0]) bbox[1][0] = vert.x;
    if (vert.y < bbox[0][1]) bbox[0][1] = vert.y;
    else if (vert.y > bbox[1][1]) bbox[1][1] = vert.y;
    if (vert.z < bbox[0][2]) bbox[0][2] = vert.z;
    else if (vert.z > bbox[1][2]) bbox[1][2] = vert.z;
  }

  // Setup initial viewing scale
  float dx = bbox[1][0] - bbox[0][0];
  float dy = bbox[1][1] - bbox[0][1];
  float dz = bbox[1][2] - bbox[0][2];
  scale = 2.0 / sqrt(dx*dx + dy*dy + dz*dz);

  // Setup initial viewing center
  center[0] = 0.5 * (bbox[1][0] + bbox[0][0]);
  center[1] = 0.5 * (bbox[1][1] + bbox[0][1]);
  center[2] = 0.5 * (bbox[1][2] + bbox[0][2]);

  // Run main loop -- never returns 
  glutMainLoop();   //glut Ϣ¼
}


//======================================================
void timerFunction(int value)   //ʱ
{
	//rotation[0] += -0.6 * (100 - GLUTmouse[1]);
    //rotation[2] += 0.6 * (100 - GLUTmouse[0]);
	glutPostRedisplay();		

	ScreenShot(hSrcDC, pointPositive, pointNegative);
    glutTimerFunc(1000, timerFunction,1);
}


void timerFunction1(int value)   //ʱ
{
	//rotation[0] += -0.6 * (100 - GLUTmouse[1]);
	rotation[2] += 0.6 * (100 - GLUTmouse[1]);
	//Mesh * mesh = ReadOffFile(filename);
    
	if(b%6==0)
	{
		a++;
		filename = glfilename();
		mesh = ReadOffFile(filename);
		b = 0;
	}
	b++;
	glutPostRedisplay();
	
    glutTimerFunc(1000, timerFunction1,2);
}


void GLUTInit()
{
  // Open window 
  //glutInit(argc, argv);  
  glutInitWindowPosition(100, 100);    
  glutInitWindowSize(GLUTwindow_width, GLUTwindow_height);
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH); //Ϊóʼʾģʽ
  GLUTwindow = glutCreateWindow("OpenGL Viewer");

  //Initialize GLUT callback functions 
  
  glutReshapeFunc(GLUTResize); //ӦĻڴСĸı(ûɶ)
  glutDisplayFunc(GLUTRedraw); //עһͼ
	//glutReshapeFunc(&Reshape);
    //glutDisplayFunc(&display);


  glutKeyboardFunc(GLUTKeyboard);//עӦ¼
  glutSpecialFunc(GLUTSpecial);//4򰴼Ӧ
  glutMouseFunc(GLUTMouse);//עӦ¼
  //glutMotionFunc(GLUTMotion); //ת
  glutIdleFunc(0);
    
  // Initialize lights 
  static GLfloat lmodel_ambient[] = { 0.2, 0.2, 0.2, 1.0 };
  glLightModelfv(GL_LIGHT_MODEL_AMBIENT, lmodel_ambient);//ùģͲ
  glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER, GL_TRUE); //ѡ 
  static GLfloat light0_diffuse[] = { 1.0, 1.0, 1.0, 1.0 };
  glLightfv(GL_LIGHT0, GL_DIFFUSE, light0_diffuse);  //Դ
  glEnable(GL_LIGHT0);   //øֹ
  static GLfloat light1_diffuse[] = { 0.5, 0.5, 0.5, 1.0 };
  glLightfv(GL_LIGHT1, GL_DIFFUSE, light1_diffuse);
  glEnable(GL_LIGHT1);
  glEnable(GL_NORMALIZE);
  glEnable(GL_LIGHTING);

  // Initialize graphics modes 
  glEnable(GL_DEPTH_TEST);
}


int 
ParseArgs(int argc, char **argv)
{
  // Innocent until proven guilty
  int print_usage = 0;

  // Parse arguments
  argc--; argv++;
  while (argc > 0) {
    if ((*argv)[0] == '-') {
      if (!strcmp(*argv, "-help")) { print_usage = 1; }
      else { fprintf(stderr, "Invalid program argument: %s", *argv); exit(1); }
      argv++; argc--;
    }
	
    else {
      if (!filename) filename = *argv;
      else { fprintf(stderr, "Invalid program argument: %s", *argv); exit(1); }
      argv++; argc--;
    }
  }

  // Check filename
  if (!filename || print_usage) {
    printf("Usage: offviewer <filename>\n");
    return 0;
  }

  // Return OK status 
  return 1;
}


NOTIFYICONDATA g_nid;
HINSTANCE g_hInstance;
HWND g_hWnd;
BOOL g_State = FALSE;

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	HWND hWndPre;
	if(hWndPre = FindWindow("MYSCREENSHOT", 0))
		//SendMessage(hWndPre, WM_DESTROY, 0, 0);
		ExitProcess(0);

//	g_hInstance = hInstance;
	HWND hWnd;
	MSG msg;
	WNDCLASSEX WndClass;
	MyRegisterClass(&WndClass, hInstance);

	if (!(hWnd = InitInstance(hInstance, nCmdShow))) 
		return FALSE;
	g_hWnd = hWnd;

	g_nid.cbSize = sizeof(NOTIFYICONDATA);
	g_nid.hWnd = hWnd;   
	g_nid.uID = 0;
	g_nid.uFlags = NIF_ICON | NIF_MESSAGE |NIF_TIP;   
	g_nid.uCallbackMessage = MY_ICON_MESSAGE;
	g_nid.hIcon = LoadIcon(hInstance,(LPCTSTR)IDI_OFF); 
	strcpy_s(g_nid.szTip, "Screenshot Helper v1.0\nCONTROL+ALT+A to start.\nSUN 2012");
	Shell_NotifyIcon(NIM_ADD,&g_nid);

  // Initialize GLUT
    GLUTInit(/*&argc, argv*/);
	mesh = ReadOffFile(filename);
    glutTimerFunc(100, timerFunction, 1); 
	glutTimerFunc(1000, timerFunction1, 2); 
    

    GLUTMainLoop();   

	ScreenShot(hSrcDC, pointPositive, pointNegative);
	
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	
	//return msg.wParam;
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{

	switch (message) 
	{
	case WM_PAINT:
		{
			hdc = BeginPaint(hWnd, &ps);
				if(g_State)
				{
					InvalidateRect(hWnd, 0, TRUE);
					HPEN hPen = CreatePen(PS_DOT, 1, RGB(0,0,0));
					HPEN hOldPen = (HPEN)SelectObject(hdc, hPen);
					MoveToEx(hdc, pointPositive.x, pointPositive.y, 0);
					LineTo(hdc, pointPresent.x, pointPositive.y);
					MoveToEx(hdc, pointPresent.x, pointPositive.y, 0);
					LineTo(hdc, pointPresent.x, pointPresent.y);
					MoveToEx(hdc, pointPresent.x, pointPresent.y, 0);
					LineTo(hdc, pointPositive.x, pointPresent.y);
					MoveToEx(hdc, pointPositive.x, pointPresent.y, 0);
					LineTo(hdc, pointPositive.x, pointPositive.y);
					hPen = (HPEN)SelectObject(hdc, hOldPen);
				}
			EndPaint(hWnd, &ps);
		}
		break;

	case WM_DESTROY:
		{
			Shell_NotifyIcon(NIM_DELETE, &g_nid);
			UnregisterHotKey(hWnd, 1346);
			UnregisterHotKey(hWnd, 1347);
			PostQuitMessage(0);
		}
		break;

	case MY_ICON_MESSAGE:
		{
			switch(lParam)
			{
			case WM_RBUTTONDOWN:
				{
					HMENU hMenu = CreateMenu();
					HMENU hPopupMenu = CreateMenu();
					AppendMenu(hMenu, MF_POPUP, (UINT_PTR)hPopupMenu, 0);
					AppendMenu(hPopupMenu, MF_STRING, IDM_RUN, "&Run");
					AppendMenu(hPopupMenu, MF_SEPARATOR, 0, 0);
					AppendMenu(hPopupMenu, MF_STRING, IDM_QUIT, "&Quit");
					POINT point;
					GetCursorPos(&point);
					SetForegroundWindow(hWnd);
					TrackPopupMenu(hPopupMenu, TPM_LEFTALIGN, point.x, point.y, 0, hWnd, 0);
				}
				break;

			case WM_LBUTTONDBLCLK:
				SendMessage(hWnd, WM_COMMAND, MAKEWPARAM(IDM_RUN, 0), 0);
				break;
			}
		}
		break;

	case WM_COMMAND:
		{
			switch (LOWORD(wParam))
			{
			case IDM_QUIT:
				DestroyWindow(hWnd);
				break;
			case IDM_RUN:
				{
					g_nid.hIcon = LoadIcon(g_hInstance, (LPCTSTR)IDI_ON); 
					Shell_NotifyIcon(NIM_MODIFY, &g_nid);
				
					hSrcDC = GetDC(GetDesktopWindow());

					HMODULE hModule = LoadLibrary("User32.dll");
					lpfnSetLayeredWindowAttributes myfunc = (lpfnSetLayeredWindowAttributes)GetProcAddress(hModule, "SetLayeredWindowAttributes"); 
					FreeLibrary(hModule);
					ShowWindow(hWnd, SW_MAXIMIZE);
					myfunc(hWnd, 0, 100, LWA_ALPHA);

					g_State = TRUE;
				}
				break;
			}
		}
		break;
		
	case WM_LBUTTONDOWN:
		{
			if(g_State)
			{
				GetCursorPos(&pointPositive);
				GetCursorPos(&pointPresent);
			}
		}
		break;

	case WM_LBUTTONUP:
		{
			if(g_State)
			{
				GetCursorPos(&pointNegative);
				ScreenShot(hSrcDC, pointPositive, pointNegative);

				SendMessage(hWnd, WM_HIDE, 0, 0);
			}
		}
		break;

	case WM_KEYDOWN:
		{
			if(wParam == VK_SPACE || wParam == VK_ESCAPE)
				SendMessage(hWnd, WM_HIDE, 0, 0);
		}
		break;

	case WM_RBUTTONDOWN:
		{
			SendMessage(hWnd, WM_HIDE, 0, 0);
		}
		break;

	case WM_HOTKEY:
		{
			if(HIWORD(lParam) == 65 || HIWORD(lParam) == 222)
				SendMessage(hWnd, WM_COMMAND, MAKEWPARAM(IDM_RUN, 0), 0);
		}
		break;
		
	case WM_HIDE:
		{
			if(g_State)
			{
				ShowWindow(hWnd, SW_SHOWNORMAL);

				g_nid.hIcon = LoadIcon(g_hInstance, (LPCTSTR)IDI_OFF); 
				Shell_NotifyIcon(NIM_MODIFY, &g_nid);

				g_State = FALSE;
				pointPositive.x = pointPositive.y = pointPresent.x = pointPresent.y = 0;
			}
		}
		break;
	case WM_MOUSEMOVE:
		{
			if(g_State && wParam == MK_LBUTTON)
			{
				pointPresent.x = LOWORD(lParam);
				pointPresent.y = HIWORD(lParam);
			}
		}
		break;

	default:
		return DefWindowProc(hWnd, message, wParam, lParam);	
   }

   return 0;
}

BOOL ScreenShot(HDC hSrcDC, POINT p1, POINT p2)
{
	//================================================================
	int nCX = 300;
	int nCY = 300;
	HWND aa = ::FindWindow("GLUT","OpenGL Viewer");
	HDC dc = ::GetDC(aa);
	HDC hMemDC = ::CreateCompatibleDC(dc);
	HBITMAP hBitmap= ::CreateCompatibleBitmap(dc,nCX,nCY);
	::SelectObject(hMemDC,hBitmap);

	::BitBlt(hMemDC,0,0,nCX,nCY,dc,240,150,SRCCOPY);

	
	char pszPath[40] = "res1\\a\\";
	char pszPath5[20];
	filename = strtok(filename,".");
	strcpy(pszPath5,filename);
	strcat_s(pszPath,40,pszPath5);
	strcat_s(pszPath,40,"(");
	char pictureNum[4];
    itoa(b,pictureNum,10);
	strcat_s(pszPath,40,pictureNum);
	strcat_s(pszPath,40,")");
	strcat_s(pszPath,40,".jpg");

	CImage image;
	image.Attach(hBitmap);
	image.Save(pszPath);
	image.Detach();

	::DeleteObject(hBitmap);
	::DeleteDC(hMemDC);
	::ReleaseDC(::GetDesktopWindow(),dc);
	return TRUE;
}


