import tensorflow as tf
from tensorflow import keras
from keras import Model,Sequential
from keras.layers import Flatten, Dense, Conv2D, GlobalAveragePooling2D, Activation, Reshape, multiply, Multiply, \
    Lambda, concatenate, BatchNormalization, add, Dropout
from keras.layers import Input, MaxPooling2D, GlobalMaxPooling2D
from keras import backend as K

def innotion(x,y):
    return x + y

def MYnet(num_classes):
    # 224，224，3
    image_input = Input(shape = (224,224,3))
    # 第一个卷积部分
    # 224，224，32 ->112,112,32
    input = Conv2D(32,(11,11),activation = 'relu',padding = 'same' ,name = 'block1_conv1',kernel_regularizer=keras.regularizers.l2(0.001))(image_input)
    # x = Conv2D(32,(5,5),activation = 'relu',padding = 'same' ,name = 'block1_conv2')(x)
    squeeze = GlobalAveragePooling2D()(input)
    excitation = Dense(units=32 // 4)(squeeze)
    excitation = Activation('relu')(excitation)
    excitation = Dense(units=32)(excitation)
    excitation = Activation('sigmoid')(excitation)
    excitation = Reshape((1, 1, 32))(excitation)
    x = multiply([input, excitation])
    x = MaxPooling2D((2,2), strides = (2,2), name = 'block1_pool')(x)
    # input = Dropout(0.2)(input)


    # 第二个卷积部分
    # 112，112，32 -> 56,56,64
    input2 = Conv2D(32,(3,3),activation = 'relu',padding = 'same',name = 'block2_conv1',kernel_regularizer=keras.regularizers.l2(0.001))(x)
    # x = Conv2D(64,(3,3),activation = 'relu',padding = 'same',name = 'block2_conv2',kernel_regularizer=keras.regularizers.l2(0.001))(x)
    # x = Conv2D(32,(3,3),activation = 'relu',padding = 'same',name = 'block2_conv3',kernel_regularizer=keras.regularizers.l2(0.001))(x)
    squeeze = GlobalAveragePooling2D()(input2)
    excitation = Dense(units=32 // 4)(squeeze)
    excitation = Activation('relu')(excitation)
    excitation = Dense(units=32)(excitation)
    excitation = Activation('sigmoid')(excitation)
    excitation = Reshape((1, 1, 32))(excitation)
    x = multiply([x, excitation])
    # con1 = concatenate([input,input2])
    add1 = add([x,input2])
    input2 = MaxPooling2D((2,2),strides = (2,2),name = 'block2_pool')(add1)
    # input2 = Dropout(0.2)(input2)


    # 第三个卷积部分
    # 56,56,64 -> 28,28,128
    x = Conv2D(64,(3,3),activation = 'relu',padding = 'same',name = 'block3_conv1',kernel_regularizer=keras.regularizers.l2(0.001))(input2)
    # x = Conv2D(64,(3,3),activation = 'relu',padding = 'same',name = 'block3_conv2',kernel_regularizer=keras.regularizers.l2(0.001))(x)
    # con2 = add([input2,x])
    squeeze = GlobalAveragePooling2D()(x)
    excitation = Dense(units=64 // 4)(squeeze)
    excitation = Activation('relu')(excitation)
    excitation = Dense(units=64)(excitation)
    excitation = Activation('sigmoid')(excitation)
    excitation = Reshape((1, 1, 64))(excitation)
    x = multiply([x, excitation])
    con1 = concatenate([input2,x])
    x = MaxPooling2D((2,2),strides = (2,2),name = 'block3_pool')(con1)
    # x = Dropout(0.2)(x)


    # 第四个卷积部分
    # 27,27,256 ->13,13,256
    # x = Conv2D(256,(3,3),activation = 'relu',padding = 'same',name = 'block4_conv1')(x)
    # x = MaxPooling2D((2,2),strides = (2,2),name = 'block4_pool')(x)



    # 第五个卷积部分
    # 7,7,512
    x = Conv2D(128,(3,3),activation = 'relu',padding = 'same', name = 'block5_conv1',kernel_regularizer=keras.regularizers.l2(0.001))(x)
    x = Conv2D(128,(3,3),activation = 'relu',padding = 'same', name = 'block5_conv2',kernel_regularizer=keras.regularizers.l2(0.001))(x)
    squeeze = GlobalAveragePooling2D()(x)
    excitation = Dense(units=128 // 8)(squeeze)
    excitation = Activation('relu')(excitation)
    excitation = Dense(units=128)(excitation)
    excitation = Activation('sigmoid')(excitation)
    excitation = Reshape((1, 1, 128))(excitation)
    x = multiply([x, excitation])
    x = MaxPooling2D((2,2),strides = (2,2),name = 'block5_pool')(x)
    x = Dropout(0.3,name='dropout2')(x)

    # 分类部分
    # 7x7x512
    # 25088
    x = Flatten(name = 'flatten')(x)
    # input2 = Flatten(name='flatten')(input2)
    # 256
    # x = Dense(256,activation = 'relu',name = 'fullc1')(x)
    # x = Dense(256,activation = 'relu',name = 'fullc1')(x)
    # # input2 = Dense(512,activation='relu',name='fullc11')(input2)
    # keras.layers.Dropout(0.5,noise_shape=None,seed=None)
    # 256
    # x = Dense(256,activation = 'relu',name = 'fullc2')(x)
    # x = Dropout(0.3)(x)
    x = Dense(512,activation = 'relu',name = 'fullc2',)(x)
    # keras.layers.Dropout(0.2,noise_shape=None,seed=None)
    # 9
    x = Dropout(0.3)(x)
    x = Dense(num_classes,activation = 'softmax',name = 'fullc3')(x)
    model = Model(image_input,x,name = 'MYnet')

    return model
