import os
import numpy as np
import utils
import cv2
import pandas as pd
from keras import backend as K
from model.newVGG16 import VGG16
# from model.MYnet_baseline import MYnet
# from model.MYnet_tongdao import MYnet
from model.MYnet_attation import MYnet
# from model.MYnet_tongdao_attation import MYnet


from keras.preprocessing import image
from keras.models import Model
from scipy.linalg import norm
import csv


import sys


sys.path.append("./img_gist_feature/")

from img_gist_feature.utils_gist import *

gist_helper = GistUtils()

K.set_image_dim_ordering('tf')

# 标准化（归一化）
def Z_Score(data):
    lenth = len(data)
    total = sum(data)
    ave = float(total)/lenth
    tempsum = sum([pow(data[i] - ave,2) for i in range(lenth)])
    tempsum = pow(float(tempsum)/lenth,0.5)
    for i in range(lenth):
        data[i] = (data[i] - ave)/tempsum
    return data


def searchlable(filename):
    if filename.split("_")[0] == 'airplane':
        return 0
    elif filename.split("_")[0] == 'car':
        return 1
    elif filename.split("_")[0] == 'chair':
        return 2
    elif filename.split("_")[0] == 'cup':
        return 3
    elif filename.split("_")[0] == 'dresser':
        return 4
    elif filename.split("_")[0] == 'lamp':
        return 5
    elif filename.split("_")[0] == 'person':
        return 6
    elif filename.split("_")[0] == 'plant':
        return 7
    else:
        return 8


#提取单个图片的特征
# def read_image(testimg_path,save_path):
#     model = Model(inputs=base_model.input, outputs=base_model.get_layer('fullc2').output)
#     [dirname,filename] = os.path.split(testimg_path)
#     date = []
#     lable = []
#     filename1 = []
#     img = cv2.imread(testimg_path)
#     img = cv2.cvtColor(img, cv2.COLOR_BGR2RGB)
#     img = img / 255
#     img = np.expand_dims(img, axis=0)
#     img = utils.resize_image(img, (224, 224))
#     fc2 = model.predict(img)  # 获取全连接层特征
#     filename= filename.split('.')[0]
#     lable = searchlable(filename)
#     fc2 = np.array(fc2)
#     date.append(lable)
#     for i in range(len(fc2[0])):
#         date.append(fc2[0][i])
#     print(fc2)
#     # for i in range(len(fc2)):
#     #     date.append(fc2[i])
#     # date.append(fc2)
#     date.append(filename)
#     with open('E:/sanweimoxingjiansuo/MYnetfuture/airplane.csv', 'w', newline="") as scv_file:
#         writer = csv.writer(scv_file)
#         writer.writerow(date)
#     print(date)

# 相似度计算
def read_image(testimg_path,rootdir):
    model = Model(inputs=base_model.input, outputs=base_model.get_layer('fullc2').output)
    testfuture = []
    testfc22 = []
    np_testgistt = []
    #测试图片的特征
    # listfc2 = []
    testimgggg = cv2.imread(testimg_path)
    testimg = cv2.cvtColor(testimgggg, cv2.COLOR_BGR2RGB)
    testimg = testimg / 255
    testimg = np.expand_dims(testimg, axis=0)
    testimg = utils.resize_image(testimg, (224, 224))
    testfc2 = model.predict(testimg)  # 获取CNN全连接层特征
    # print(testfc2)
    # testfc2 = Z_Score(testfc2[0]) # 归一化
    # print(testfc2)
    listtestfc2 = testfc2.tolist()
    # print(listtestfc2)

    np_testgist = gist_helper.get_gist_vec(testimgggg, mode="gray")   #获取gist特征
    # print(np_testgist)
    # np_testgist = Z_Score(np_testgist[0])
    # print(np_testgist)
    listtestgist = np_testgist.tolist()

    # 获取图片的名字
    imgname = testimg_path.split('/')[4]
    newimgname = imgname.split('.')[0]
    # 取出d1特征
    testd1 = []
    path = "E://c++d1d2d3future//test//d1//" + newimgname + ".xlsx"
    # print(path)
    data = pd.read_csv(path, index_col=False, header=None)
    # print(data)
    data_array = np.array(data)
    # print(data_array)
    data_list = data_array.tolist()
    # print(data_list)  # 此时是二维列表[[0], [32], [40], [22], [70], [216], [168], [271], [133], [45]]
    for i in range(len(data_list)):
        testd1.append(data_list[i][0] / 100)
    testd11 = np.array(testd1)
    # 取出d2特征
    testd2 = []
    path = "E://c++d1d2d3future//test//newd2//" + newimgname + ".xlsx"
    data2 = pd.read_csv(path, index_col=False, header=None)
    data_array2 = np.array(data2)
    data_list2 = data_array2.tolist()
    for i in range(len(data_list2)):
        testd2.append(data_list2[i][0] / 100)
    testd22 = np.array(testd2)

    # 取出d3特征
    testd3 = []
    path = "E://c++d1d2d3future//test//d3//" + newimgname + ".xlsx"
    data3 = pd.read_csv(path, index_col=False, header=None)
    data_array3 = np.array(data3)
    data_list3 = data_array3.tolist()
    for i in range(len(data_list3)):
        testd3.append(data_list3[i][0] / 100)
    testd33 = np.array(testd3)

    # d123混合特征 特征都拼接在一起
    mixd1d2d3 = testd1 + testd2 + testd3
    # print(mixd1d2d3)
    mixd1d2d3 = np.array(mixd1d2d3)
    # mixd1d2d3 = Z_Score(mixd1d2d3)
    listmixd1d2d3 = mixd1d2d3.tolist()

    testfuture = listtestfc2 + listtestgist + listmixd1d2d3
    # print(testfuture)
    testfuture = np.array(testfuture)
    # print(testfuture)

    # testfcc = Z_Score(testfc)  # 特征标准化
    # testfc2 /= norm(testfc2)  # 特征归一化

    listdistance = []
    listlable = []
    i=0
    # distancefile = "E://sanweimoxingjiansuo//VGG16future//distance//vgg16oushijuli.xls"

    #待查询所有图片的特征
    for filename in os.listdir(rootdir):
        fc22 = []
        np_gistt = []
        future = []
        # print(filename) #just for test
        # img is used to store the image data
        imgggg = cv2.imread(rootdir + '/'+ filename)
        img = cv2.cvtColor(imgggg, cv2.COLOR_BGR2RGB)
        img = img / 255
        img = np.expand_dims(img, axis=0)
        img = utils.resize_image(img, (224, 224))
        fc2 = model.predict(img)  # 获取VGG16全连接层特征
        # fc2 = Z_Score(fc2[0])
        listfc2 = fc2.tolist()
        # print(listfc2)

        np_gist = gist_helper.get_gist_vec(imgggg, mode="gray") # 获取gist特征
        # print(np_gist)
        # np_gist = Z_Score(np_gist[0])
        # print(np_gist)
        listgist = np_gist.tolist()

        newfilename = filename.split('.')[0]
        # 取出d1特征
        d1 = []
        path = "E://c++d1d2d3future//d1//" + newfilename + ".xlsx"
        # print(path)
        data = pd.read_csv(path, index_col=False, header=None)
        # print(data)
        data_array = np.array(data)
        # print(data_array)
        data_list = data_array.tolist()
        # print(data_list) #此时是二维列表[[0], [32], [40], [22], [70], [216], [168], [271], [133], [45]]
        for i in range(len(data_list)):
            d1.append(data_list[i][0] / 100)
        d11 = np.array(d1)
        # 取出d2特征
        d2 = []
        path = "E://c++d1d2d3future//newd2//" + newfilename + ".xlsx"
        data2 = pd.read_csv(path, index_col=False, header=None)
        data_array2 = np.array(data2)
        data_list2 = data_array2.tolist()
        for i in range(len(data_list2)):
            d2.append(data_list2[i][0] / 100)
        d22 = np.array(d2)
        # 取出d3特征
        d3 = []
        path = "E://c++d1d2d3future//d3//" + newfilename + ".xlsx"
        data3 = pd.read_csv(path, index_col=False, header=None)
        data_array3 = np.array(data3)
        data_list3 = data_array3.tolist()
        for i in range(len(data_list3)):
            d3.append(data_list3[i][0] / 100)
        d33 = np.array(d3)

        # 混合特征
        mix = d1 + d2 + d3
        mix = np.array(mix)
        # mix = Z_Score(mix)
        listmix = mix.tolist()

        future = listfc2 + listgist + listmix
        future = np.array(future)

        #特征先融合，只有一个距离计算
        # distancemix = np.sqrt(np.sum(np.square(testfuture - future))) # 混合特征的欧氏距离

        # 距离分开计算
        distance1 = np.sqrt(np.sum(np.square(testfc2 - fc2)))   # cnn欧氏距离
        # print(distance1)
        distance2 = np.sqrt(np.sum(np.square(np_testgist - np_gist)))   # gist欧氏距离
        # print(distance2)
        distance3 = np.sqrt(np.sum(np.square(mixd1d2d3 - mix)))  # d123的欧氏距离
        # print(distance3)
        # distance = (distance1/10) + distance2
        distance = (distance1/10)*0.6 + distance2*0.3 + distance3*0.1
        filename = filename.split('.')[0]
        # listdistance.append(distance)
        listdistance.append(distance1)
        listlable.append(filename)
    result=dict(zip(listlable,listdistance))#输出是字典格式
    sortedresult = sorted(result.values())
    print(sortedresult)
    # with open('E:/sanweimoxingjiansuo/MYnetfuture/lastmix/cnn&gist&d1d2d3/zscore_mix_airplane_1.csv','w',newline="") as scv_file:
    #     writer = csv.writer(scv_file)
    #     for key,value in result.items():
    #         writer.writerow([key,value])

    with open('E:/sanweimoxingjiansuo/MYnetfuture/lastmix/cnn&gist&d1d2d3/mix_table_3.csv','w',newline="") as scv_file:
        writer = csv.writer(scv_file)
        for key,value in result.items():
            writer.writerow([key,value])

if __name__ == "__main__":
    # base_model = VGG16(9)
    base_model = MYnet(9)
    base_model.load_weights("./logs/Mynet_mix_attention_20200523.h5")

    testimg_path = "./data/image/test/table_3.png"
    rootdir = "E:/sanweimoxingjiansuo/canny view/all"  # 图片路径
    # rootdir = "E:/sanweimoxingjiansuo/canny view/test"  # 图片路径
    # save_path = "E:/sanweimoxingjiansuo/MYnetfuture"  # 提取特征文件保存路径
    # 提取单个文件的特征并保存
    # read_image(testimg_path,save_path)

    #提取文件夹下的所有特征，并保存为一个npy文件（但是标签没法输入）
    # read_image(rootdir)

    #提取特征进行相似度检索
    read_image(testimg_path,rootdir)
